library(mvtnorm)

kritwerte <- function(hattf=0.5,hattg=0.5,dotlambda1=0.375,dotlambda2=0.375,n=5000,m=5000)
{
counter <- rep(0,m)
#set.seed(1)
for(i in 1:m)
{
print(i)
daten <- rnorm(n)
bbewegung <- cumsum(daten)/sqrt(n)
Sn <- max(abs(bbewegung))
counter[i] <- Sn
}
return(sort(counter)[0.95*m])
}

library(mvtnorm)

cusumcctest <- function(x,sumpi)
{
n <- length(x)
ergebnis <- cumsum(x) - (1:n) * sumpi
ergebnis <- 1/sqrt(n) * abs(ergebnis)
ergebnis <- max(ergebnis)/sd(x)
return(ergebnis)
}

## Simulationen

m <- 1000
n <- 250
d <- 5
p <- 0.15
delta <- 0*p
alpha <- 0.05
rho1 <- 0.5
sigma1 <- matrix(rho1,ncol=d,nrow=d)
diag(sigma1) <- rep(1,d)
rho2 <- 0.5
sigma2 <- matrix(rho2,ncol=d,nrow=d)
diag(sigma2) <- rep(1,d)
sigma2 <- sigma2
zaehler <- rep(0,m)
for(i in 1:m)
{
print(mean(zaehler[1:i]))
#x <- c(rbinom(n,d,p),rbinom(n,d,p))
#x <- 20*rbinom(n,1,p)
#x <- rbinom(n+10000,20,0.5)
#x <- filter(x,0.1,method="recursive")
#x <- floor(x)
#x <- x[which(x <= 20)]
#x <- x[which(x >= 0)]
#x <- x[(length(x)-n+1):(length(x))]
x1 <- matrix(0,ncol=d,nrow=n/4)
x1 <- t(apply(x1,1,function(y) rmvnorm(1,rep(0,5),sigma1)))
x1 <- x1 < qnorm(p-2*delta)
x1 <- rowSums(x1)
#x1 <- apply(x1,1,function(x) sum(x < qnorm(p-2*delta)))
x2 <- matrix(0,ncol=d,nrow=n/4)
x2 <- t(apply(x2,1,function(y) rmvnorm(1,rep(0,5),sigma1)))
x2 <- apply(x2,1,function(x) sum(x < qnorm(p+delta)))
x3 <- matrix(0,ncol=d,nrow=n/4)
x3 <- t(apply(x3,1,function(y) rmvnorm(1,rep(0,5),sigma2)))
x3 <- apply(x3,1,function(x) sum(x < qnorm(p-delta)))
x4 <- matrix(0,ncol=d,nrow=n/4)
x4 <- t(apply(x4,1,function(y) rmvnorm(1,rep(0,5),sigma2)))
x4 <- apply(x4,1,function(x) sum(x < qnorm(p+2*delta)))
x <- c(x1,x2,x3,x4)
rcpwert <- cusumcctest(x,d*0.05)
zaehler[i] <- rcpwert > 2.2
}
mean(zaehler)